#include "C_fastRTSExamplecfg.h"
#include <c64.h>
#include <clk.h>

#include <fastrts_i.h>      // has to be included after the sys.h (which is included by other DSP/BIOS headers) because it creates a "errno" type.

#define N (16)

Void inline_usage()
{
    float left [N] = { 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8,
                       0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6};

    float right [N] = { 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9,
                        1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7};

    float add_res[N], mult_res[N];
    int i;

    STS_set(&addSts, CLK_gethtime());
    for(i = 0; i < N; i++){
        add_res[i] = addsp_i(left[i], right[i]);
    }
    STS_delta(&addSts, CLK_gethtime());

    STS_set(&multiplySts, CLK_gethtime());
    for(i = 0; i < N; i++){
        mult_res[i] = mpysp_i(add_res[i], right[i]);
    }
    STS_delta(&multiplySts, CLK_gethtime());
}

extern "C" Void C_fastRTSExampleFxn()
{
    LOG_printf(&trace, "C_fastRTSExampleFxn");

    for (;;)
    {
        inline_usage();

        TSK_sleep(500);
    }
}

Int main()
{
    LOG_printf(&trace, "C_fastRTSExample");
}
